//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 0.01;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 300;
extern bool UseTakeProfit = True;
extern int TakeProfit = 100;
extern bool UseTrailingStop = True;
extern int TrailingStop = 12;

extern string  About = "<<< Instant Trade Analyzer >>>";

extern string  AnalyzerSetting = "<<< Analyzer Setting >>>";
extern bool    ChartSymbolOnly = false;
extern int     SpecificMagic = 0;

extern bool    UsePeriod = false;
extern string  From = "2009.01.01";
extern string  Till = "2012.02.01";

extern string  KellySetting = "<<< Optimal f (Kelly) Setting >>>";
extern double  Fractional_Kelly = 0.25;
extern int     StopLoss_for_Kellylot = 100;

extern string  SkipCommentSetting = "<<< Skip Comment Setting >>>";
extern string  SkipComment_1 = "Deposit";
extern string  SkipComment_2 = "";
extern string  SkipComment_3 = "";
extern string  SkipComment_4 = "";
extern string  SkipComment_5 = "";

string EANAME = "Instant Trade Analyzer";

string SkipComment[];
int SkipComments;

int DQ_ADJUST []  = { 0 , 0 , 1 , 10 , 1 , 10 , 100 };
int DQADJ, Ldig, DIGITS;

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   DQADJ = DQ_ADJUST [ DIGITS ];

   Ldig = 2;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.07) Ldig = 1;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.7) Ldig = 0;

   int i=0;
   if(SkipComment_1 != "") { SkipComment[i] = SkipComment_1; i++; }
   if(SkipComment_2 != "") { SkipComment[i] = SkipComment_2; i++; }
   if(SkipComment_3 != "") { SkipComment[i] = SkipComment_3; i++; }
   if(SkipComment_4 != "") { SkipComment[i] = SkipComment_4; i++; }
   if(SkipComment_5 != "") { SkipComment[i] = SkipComment_5; i++; }

   SkipComments = i;

   Trade_Analyzer();
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   Trade_Analyzer();


   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+
double high = iHigh(NULL,1440,1);
double low = iLow(NULL,1440,1);
double close = iClose(NULL,1440,1);
double P = (high+low+close)/3;

double Buy1_1 = iOpen(NULL, 0, Current + 0);
double Buy1_2 = P;

double Sell1_1 = iOpen(NULL, 0, Current + 0);
double Sell1_2 = P;

double CloseBuy1_1 = iOpen(NULL, 0, Current + 0);
double CloseBuy1_2 = P;

double CloseSell1_1 = iOpen(NULL, 0, Current + 0);
double CloseSell1_2 = P;

   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

                     if (CloseBuy1_1 > CloseBuy1_2) Order = SIGNAL_CLOSEBUY;


            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

                     if (CloseSell1_1 < CloseSell1_2) Order = SIGNAL_CLOSESELL;


            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (Buy1_1 < Buy1_2) Order = SIGNAL_BUY;

   if (Sell1_1 > Sell1_2) Order = SIGNAL_SELL;


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

//+------------------------------------------------------------------+
//| Trade Analyzer
//+------------------------------------------------------------------+
void Trade_Analyzer()
{
   string ln = "\n";
   string DAAAAASH = "---------------------------------------------------------------" +ln;

   double BUY_TRADES = Trades(0);
   double SELL_TRADES = Trades(1);
   double TOTAL_TRADES = BUY_TRADES + SELL_TRADES;
   
   if(OrdersHistoryTotal() < 1 || TOTAL_TRADES < 0.9)
   {
      Comment( DAAAAASH + EANAME +ln+ DAAAAASH + "No History to analyze." );
      return(0);
   }

   string COMMENT = "";

// Analyzer Condition --------------------------------------

   // Period
   int PeriodStart = PeriodSearch("Start");
   int PeriodEnd = PeriodSearch("End");
   double PERIOD = PeriodEnd - PeriodStart;

   double PERIODinDAYS = PERIOD/86400;

   if(UsePeriod) COMMENT = COMMENT + "Period : "+ TS(StrToTime(From),"Day") +" - "+ TS(StrToTime(Till),"Day")+" ("+DS2(PERIODinDAYS)+"days)" +ln;
   if(!UsePeriod) COMMENT = COMMENT + "Period : "+ TS(PeriodStart,"Day") +" - "+ TS(PeriodEnd,"Day")+" ("+DS2(PERIODinDAYS)+"days)" +ln;

   // Symbol
   string SYMBOL = "All Symbol";
   if(ChartSymbolOnly) SYMBOL = "Chart Symbol Only ("+Symbol()+")";
   COMMENT = COMMENT + "Symbol : " + SYMBOL +ln;

   // Magic
   string MAGIC = "All Magic";
   if(SpecificMagic > 0) MAGIC = SpecificMagic + " Only";
   COMMENT = COMMENT + "Magic : " + MAGIC +ln;
   
   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

// Statistics --------------------------------------

   double BUY_WINS = Wins(0); double BUY_LOSSES = BUY_TRADES - BUY_WINS; 
   double SELL_WINS = Wins(1); double SELL_LOSSES = SELL_TRADES - SELL_WINS; 
   double TOTAL_WINS = BUY_WINS + SELL_WINS; double TOTAL_LOSSES = TOTAL_TRADES - TOTAL_WINS; 

   // Winning Average
   double WinAv_Total = 0.0;
   if(TOTAL_TRADES > 0.001) WinAv_Total = TOTAL_WINS / TOTAL_TRADES;

   double WinAv_Buy = 0.0;
   if(BUY_TRADES > 0.001) WinAv_Buy = BUY_WINS / BUY_TRADES;
   
   double WinAv_Sell = 0.0;
   if(SELL_TRADES > 0.001) WinAv_Sell = SELL_WINS / SELL_TRADES;

   double TradeFrequency = 0.0;
   if(PERIODinDAYS > 0.001) TradeFrequency = TOTAL_TRADES / PERIODinDAYS;

   COMMENT = COMMENT + "Trades : " + DS0(TOTAL_TRADES) +" (Total) / "+DS0(BUY_TRADES) +" (buy) / "+DS0(SELL_TRADES) +" (sell)" +ln;
   COMMENT = COMMENT + "Trade Frequency : "+ DS2( TradeFrequency ) + " trades / day"+ln;

   COMMENT = COMMENT + "Win. Average (Total) : " + DS2(WinAv_Total*100) +"%"+ln;
   COMMENT = COMMENT + "Win. Average (Buy) : " + DS2(WinAv_Buy*100) +"%"+ln;
   COMMENT = COMMENT + "Win. Average (Sell) : " + DS2(WinAv_Sell*100) +"%"+ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

   // Average P/L
   double Buy_Profit = Profit(0);
   double Sell_Profit = Profit(1);
   double Total_Profit = Buy_Profit + Sell_Profit;
   double Buy_Loss = Loss(0);
   double Sell_Loss = Loss(1);
   double Total_Loss = Buy_Loss + Sell_Loss;

   double Total_PL = Total_Profit - Total_Loss;

   double Av_Profit_Total = 0.0;
   if(TOTAL_WINS > 0.001) Av_Profit_Total = Total_Profit / TOTAL_WINS;

   double Av_Loss_Total = 0.0;
   if(TOTAL_LOSSES > 0.001) Av_Loss_Total = Total_Loss / TOTAL_LOSSES;

   double PL_RATIO_Total = 0.0;
   if(Av_Loss_Total > 0.001) PL_RATIO_Total = Av_Profit_Total / Av_Loss_Total;

   COMMENT = COMMENT + "Total P/L : "+DS2(Total_PL) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Average Win : "+DS2(Av_Profit_Total) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Average Loss : "+DS2(Av_Loss_Total) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Profit / Loss Ratio : "+DS2(PL_RATIO_Total) +ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

// Yardsticks ---------------------------------------------------------------------

   // Profit Factor
   double ProfitFactor = 0.0;
   if(Total_Loss > 0.001) ProfitFactor = Total_Profit / Total_Loss;
   COMMENT = COMMENT + "Profit Factor : "+DS2(ProfitFactor) +ln;

   // Success Score
   COMMENT = COMMENT + "Success Score : "+DS2(PL_RATIO_Total * WinAv_Total * 100) +ln;
   
   // BreakEven Rate
   double Recovery = 0.0;
   if(Av_Profit_Total > 0.001) Recovery = Av_Loss_Total / Av_Profit_Total;

   double BreakEvenRate = Recovery / (1 + Recovery);
   COMMENT = COMMENT + "BreakEven Rate : "+DS2(BreakEvenRate * 100) + "%" +ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

   // Optimal f (Kelly)
   double Optimal_f = 0.0;
   if(PL_RATIO_Total > 0.001) Optimal_f = ( (PL_RATIO_Total + 1) * WinAv_Total - 1 ) / PL_RATIO_Total;

   COMMENT = COMMENT + "Optimal f (Kelly) : "+DS2(Optimal_f * 100) +"%" +ln;
   if(Fractional_Kelly < 0.9999) COMMENT = COMMENT + "Fractional Kelly ("+DS2(Fractional_Kelly)+") : "+DS2(Optimal_f*Fractional_Kelly*100) +"%" +ln;

   string Fractional = ""; if(Fractional_Kelly < 0.9999) Fractional = ", Fractional";

   double Kellylot = 0.0;
   if(StopLoss_for_Kellylot>0.001) Kellylot = (AccountBalance() * Optimal_f*Fractional_Kelly) / ( MarketInfo(Symbol(),MODE_TICKVALUE) * StopLoss_for_Kellylot * DQADJ );
   
   COMMENT = COMMENT + "Risk by Optimal f : "+DoubleToStr(Kellylot,Ldig) +" lot (SL : "+StopLoss_for_Kellylot+"pips"+Fractional+")" +ln;

   Comment(
            DAAAAASH + EANAME +ln+
            DAAAAASH + COMMENT
          );
}  

//+------------------------------------------------------------------+
//| DS2 (string) double Val
//+------------------------------------------------------------------+
string DS2(double Val)
{
   return(DoubleToStr(Val,2));
}

//+------------------------------------------------------------------+
//| DS0 (string) double Val
//+------------------------------------------------------------------+
string DS0(double Val)
{
   return(DoubleToStr(Val,0));
}

//+------------------------------------------------------------------+
//| TS (string) int SEC
//+------------------------------------------------------------------+
string TS(int SEC, string Mode)
{
   if(Mode == "Day") return( TimeToStr(SEC, TIME_DATE) );
   if(Mode == "Min") return( TimeToStr(SEC, TIME_DATE|TIME_MINUTES) );
}

//+------------------------------------------------------------------+
//| PeriodSearch (datetime)
//+------------------------------------------------------------------+
datetime PeriodSearch(string Mode)
{
   datetime PeriodStart = 161059999999;
   datetime PeriodEnd = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() > 1) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;

      if(Mode == "Start") PeriodStart = MathMin(PeriodStart,OrderCloseTime());
      if(Mode == "End") PeriodEnd = MathMax(PeriodEnd,OrderCloseTime());
   }

   if(Mode == "Start") return(PeriodStart);
   if(Mode == "End") return(PeriodEnd);
}  

//+------------------------------------------------------------------+
//| IsSkip (bool)
//+------------------------------------------------------------------+
bool IsSkip(string ORDERSYMBOL, int ORDERMAGIC, string ORDERCOMMENT, datetime ORDEROPENTIME, datetime ORDERCLOSETIME)
{
   if(ChartSymbolOnly && Symbol() != ORDERSYMBOL) return(true); // symbol check
   if(SpecificMagic > 0 && ORDERMAGIC != SpecificMagic) return(true); // magic check
   if( IsSkipComment( ORDERCOMMENT ) ) return(true); // comment check
   if( UsePeriod && IsOutsidePeriod( ORDEROPENTIME, ORDERCLOSETIME ) ) return(true); // period check

   return(false);
}  

//+------------------------------------------------------------------+
//| IsSkipComment (bool)
//+------------------------------------------------------------------+
bool IsSkipComment(string OrdComment)
{
   bool IsSkipComment = false;
   for(int i=0; i<SkipComments; i++) if(StringFind(OrdComment, SkipComment[i]) != -1) IsSkipComment = true;

   return(IsSkipComment);
}  

//+------------------------------------------------------------------+
//| IsOutsidePeriod (bool)
//+------------------------------------------------------------------+
bool IsOutsidePeriod(datetime OPEN, datetime CLOSE)
{
   bool OutsidePeriod = false;
   if(OPEN < StrToTime(From)) OutsidePeriod = true;
   if(CLOSE > StrToTime(Till)) OutsidePeriod = true;

   return(OutsidePeriod);
}  

//+------------------------------------------------------------------+
//| Trades (int)
//+------------------------------------------------------------------+
int Trades(int OrdType)
{
   int Trades = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      Trades++;
   }

   return(Trades);
}  

//+------------------------------------------------------------------+
//| Wins (int)
//+------------------------------------------------------------------+
int Wins(int OrdType)
{
   int Wins = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) Wins++;
   }

   return(Wins);
}  

//+------------------------------------------------------------------+
//| Profit (double)
//+------------------------------------------------------------------+
double Profit(int OrdType)
{
   double Profit = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) Profit += (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(Profit);
}

//+------------------------------------------------------------------+
//| Loss (double)
//+------------------------------------------------------------------+
double Loss(int OrdType)
{
   double Loss = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;

      if(OrderProfit()+OrderSwap()+OrderCommission() < 0) Loss -= (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(Loss);
}

//+------------------------------------------------------------------+